local band, bor, bnot
do
  local _obj_0 = require('bit')
  band, bor, bnot = _obj_0.band, _obj_0.bor, _obj_0.bnot
end
local CIA = require('CIA.CIA')
local KEYMAP, SCANMAP
do
  local _obj_0 = require('CIA.keys')
  KEYMAP, SCANMAP = _obj_0.KEYMAP, _obj_0.SCANMAP
end
local CIA1
do
  local _class_0
  local _base_0 = {
    keypressed = function(self, key, scan)
      self._keystate[scan] = KEYMAP[key] or SCANMAP[scan]
    end,
    keyreleased = function(self, key, scan)
      self._keystate[scan] = nil
    end,
    _readReg = function(self, reg)
      local _exp_0 = reg
      if 0x01 == _exp_0 then
        local pressed = 0x00
        local col = band(bnot(self._cia.porta), 0xff)
        for k, v in pairs(self._keystate) do
          if band(col, v[2]) == v[2] then
            pressed = bor(pressed, v[1])
          end
        end
        return band(bnot(pressed), 0xff)
      end
      return self._cia:_readReg(reg)
    end,
    _writeReg = function(self, reg, val)
      return self._cia:_writeReg(reg, val)
    end,
    tick = function(self)
      return self._cia:_tick()
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self, system)
      local read
      read = function(reg)
        return self:_readReg(reg)
      end
      local write
      write = function(reg, val)
        return self:_writeReg(reg, val)
      end
      self._cia = CIA(system, 0xdc00, read, write)
      self._keystate = { }
    end,
    __base = _base_0,
    __name = "CIA1"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  CIA1 = _class_0
  return _class_0
end
