local lshift
lshift = require('bit').lshift
local KEYMAP = {
  ['1'] = {
    0,
    7
  },
  ['2'] = {
    3,
    7
  },
  ['3'] = {
    0,
    1
  },
  ['4'] = {
    3,
    1
  },
  ['5'] = {
    0,
    2
  },
  ['6'] = {
    3,
    2
  },
  ['7'] = {
    0,
    3
  },
  ['8'] = {
    3,
    3
  },
  ['9'] = {
    0,
    4
  },
  ['0'] = {
    3,
    4
  },
  ['q'] = {
    6,
    7
  },
  ['w'] = {
    1,
    1
  },
  ['e'] = {
    6,
    1
  },
  ['r'] = {
    1,
    2
  },
  ['t'] = {
    6,
    2
  },
  ['y'] = {
    1,
    3
  },
  ['u'] = {
    6,
    3
  },
  ['i'] = {
    1,
    4
  },
  ['o'] = {
    6,
    4
  },
  ['p'] = {
    1,
    5
  },
  ['a'] = {
    2,
    1
  },
  ['s'] = {
    5,
    1
  },
  ['d'] = {
    2,
    2
  },
  ['f'] = {
    5,
    2
  },
  ['g'] = {
    2,
    3
  },
  ['h'] = {
    5,
    3
  },
  ['j'] = {
    2,
    4
  },
  ['k'] = {
    5,
    4
  },
  ['l'] = {
    2,
    5
  },
  ['z'] = {
    4,
    1
  },
  ['x'] = {
    7,
    2
  },
  ['c'] = {
    4,
    2
  },
  ['v'] = {
    7,
    3
  },
  ['b'] = {
    4,
    3
  },
  ['n'] = {
    7,
    4
  },
  ['m'] = {
    4,
    4
  },
  [','] = {
    7,
    5
  },
  ['.'] = {
    4,
    5
  },
  ['f1'] = {
    4,
    0
  },
  ['f2'] = {
    4,
    0
  },
  ['f3'] = {
    5,
    0
  },
  ['f4'] = {
    5,
    0
  },
  ['f5'] = {
    6,
    0
  },
  ['f6'] = {
    6,
    0
  },
  ['f7'] = {
    3,
    0
  },
  ['f8'] = {
    3,
    0
  }
}
local SCANMAP = {
  ['`'] = {
    1,
    7
  },
  ['-'] = {
    0,
    5
  },
  ['='] = {
    3,
    5
  },
  ['f9'] = {
    0,
    6
  },
  ['home'] = {
    3,
    6
  },
  ['backspace'] = {
    0,
    0
  },
  ['lctrl'] = {
    2,
    7
  },
  ['rctrl'] = {
    2,
    7
  },
  ['['] = {
    6,
    5
  },
  [']'] = {
    1,
    6
  },
  ['nonusbackslash'] = {
    6,
    6
  },
  ['escape'] = {
    7,
    7
  },
  [';'] = {
    5,
    5
  },
  ['\''] = {
    2,
    6
  },
  ['\\'] = {
    5,
    6
  },
  ['return'] = {
    1,
    0
  },
  ['lgui'] = {
    5,
    7
  },
  ['lalt'] = {
    5,
    7
  },
  ['lshift'] = {
    7,
    1
  },
  ['/'] = {
    7,
    6
  },
  ['rshift'] = {
    4,
    6
  },
  ['up'] = {
    7,
    0
  },
  ['down'] = {
    7,
    0
  },
  ['left'] = {
    2,
    0
  },
  ['right'] = {
    2,
    0
  },
  ['space'] = {
    4,
    7
  }
}
for k, v in pairs(SCANMAP) do
  v[1] = lshift(1, v[1])
  v[2] = lshift(1, v[2])
end
for k, v in pairs(KEYMAP) do
  v[1] = lshift(1, v[1])
  v[2] = lshift(1, v[2])
end
return {
  KEYMAP = KEYMAP,
  SCANMAP = SCANMAP
}
