local ffi = require('ffi')
local band, lshift
do
  local _obj_0 = require('bit')
  band, lshift = _obj_0.band, _obj_0.lshift
end
local SID_cdef = [[	struct __attribute__((__packed__)) {
		uint16_t v1f;
		uint16_t v1pw;
		uint8_t v1cr;
		uint8_t v1ad;
		uint8_t v1sr;
		uint16_t v2f;
		uint16_t v2pw;
		uint8_t v2cr;
		uint8_t v2ad;
		uint8_t v2sr;
		uint16_t v3f;
		uint16_t v3pw;
		uint8_t v3cr;
		uint8_t v3ad;
		uint8_t v3sr;
		uint16_t fco;
		uint8_t fcr;
		uint8_t vfm;
		uint8_t px, py;
		uint8_t v3wo;
		uint8_t v3adsro;
		uint8_t unused[3];
	}
]]
local SID
SID = function(system)
  local regs = nil
  return ffi.metatype(ffi.typeof(SID_cdef), {
    __new = function(self)
      local sid = ffi.new(self)
      regs = ffi.cast('char*', sid)
      system:addDevice(0xd400, 0xd7ff, self)
      return sid
    end,
    __index = {
      read = function(self, addr)
        addr = band(addr, 0xf71f) - 0xd400
        return regs[addr]
      end,
      write = function(self, addr, val)
        addr = band(addr, 0xf71f) - 0xd400
        regs[addr] = val
        return val
      end,
      tick = function(self) end
    }
  })()
end
return function(system)
  return SID(system)
end
